Index: /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Cell.pm
===================================================================
--- /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Cell.pm	(revision 147)
+++ /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Cell.pm	(revision 147)
@@ -0,0 +1,85 @@
+package LATMOS::Accounts::Bases::Sql::Cell;
+
+use 5.010000;
+use strict;
+use warnings;
+
+use base qw(LATMOS::Accounts::Bases::Sql::objects);
+
+our $VERSION = (q$Rev$ =~ /^Rev: (\d+) /)[0];
+
+=head1 NAME
+
+LATMOS::Ad - Perl extension for blah blah blah
+
+=head1 SYNOPSIS
+
+  use LATMOS::Accounts::Bases;
+  my $base = LATMOS::Accounts::Bases->new('sql');
+  ...
+
+=head1 DESCRIPTION
+
+Account base access over standard unix file format.
+
+=head1 FUNCTIONS
+
+=cut
+
+=head2 new(%options)
+
+Create a new LATMOS::Ad object for windows AD $domain.
+
+domain / server: either the Ad domain or directly the server
+
+ldap_args is an optionnal list of arguments to pass to L<Net::LDAP>.
+
+=cut
+
+sub object_table { 'cell' }
+
+sub key_field { 'name' }
+
+sub has_extended_attributes { 1 }
+
+sub _initial_fields {
+    my ($self, $for) = @_;
+    {
+        name => 'name',
+    }
+}
+
+sub _inline_fields {
+    my ($self, $for) = @_;
+
+    my %fields = (
+        %{ $self->_initial_fields($for) },
+    );
+    \%fields;
+}
+
+sub _delayed_fields {
+    my ($self)= @_;
+    return qw();
+}
+
+1;
+
+__END__
+
+=head1 SEE ALSO
+
+=head1 AUTHOR
+
+Olivier Thauvin, E<lt>olivier.thauvin@latmos.ipsl.frE<gt>
+
+=head1 COPYRIGHT AND LICENSE
+
+Copyright (C) 2008, 2009 CNRS SA/CETP/LATMOS
+
+This library is free software; you can redistribute it and/or modify
+it under the same terms as Perl itself, either Perl version 5.10.0 or,
+at your option, any later version of Perl 5 you may have available.
+
+
+=cut
Index: /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Department.pm
===================================================================
--- /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Department.pm	(revision 147)
+++ /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Department.pm	(revision 147)
@@ -0,0 +1,85 @@
+package LATMOS::Accounts::Bases::Sql::Department;
+
+use 5.010000;
+use strict;
+use warnings;
+
+use base qw(LATMOS::Accounts::Bases::Sql::objects);
+
+our $VERSION = (q$Rev$ =~ /^Rev: (\d+) /)[0];
+
+=head1 NAME
+
+LATMOS::Ad - Perl extension for blah blah blah
+
+=head1 SYNOPSIS
+
+  use LATMOS::Accounts::Bases;
+  my $base = LATMOS::Accounts::Bases->new('sql');
+  ...
+
+=head1 DESCRIPTION
+
+Account base access over standard unix file format.
+
+=head1 FUNCTIONS
+
+=cut
+
+=head2 new(%options)
+
+Create a new LATMOS::Ad object for windows AD $domain.
+
+domain / server: either the Ad domain or directly the server
+
+ldap_args is an optionnal list of arguments to pass to L<Net::LDAP>.
+
+=cut
+
+sub object_table { 'department' }
+
+sub key_field { 'name' }
+
+sub has_extended_attributes { 1 }
+
+sub _initial_fields {
+    my ($self, $for) = @_;
+    {
+        name => 'name',
+    }
+}
+
+sub _inline_fields {
+    my ($self, $for) = @_;
+
+    my %fields = (
+        %{ $self->_initial_fields($for) },
+    );
+    \%fields;
+}
+
+sub _delayed_fields {
+    my ($self)= @_;
+    return qw();
+}
+
+1;
+
+__END__
+
+=head1 SEE ALSO
+
+=head1 AUTHOR
+
+Olivier Thauvin, E<lt>olivier.thauvin@latmos.ipsl.frE<gt>
+
+=head1 COPYRIGHT AND LICENSE
+
+Copyright (C) 2008, 2009 CNRS SA/CETP/LATMOS
+
+This library is free software; you can redistribute it and/or modify
+it under the same terms as Perl itself, either Perl version 5.10.0 or,
+at your option, any later version of Perl 5 you may have available.
+
+
+=cut
Index: /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Team.pm
===================================================================
--- /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Team.pm	(revision 147)
+++ /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Team.pm	(revision 147)
@@ -0,0 +1,85 @@
+package LATMOS::Accounts::Bases::Sql::Team;
+
+use 5.010000;
+use strict;
+use warnings;
+
+use base qw(LATMOS::Accounts::Bases::Sql::objects);
+
+our $VERSION = (q$Rev$ =~ /^Rev: (\d+) /)[0];
+
+=head1 NAME
+
+LATMOS::Ad - Perl extension for blah blah blah
+
+=head1 SYNOPSIS
+
+  use LATMOS::Accounts::Bases;
+  my $base = LATMOS::Accounts::Bases->new('sql');
+  ...
+
+=head1 DESCRIPTION
+
+Account base access over standard unix file format.
+
+=head1 FUNCTIONS
+
+=cut
+
+=head2 new(%options)
+
+Create a new LATMOS::Ad object for windows AD $domain.
+
+domain / server: either the Ad domain or directly the server
+
+ldap_args is an optionnal list of arguments to pass to L<Net::LDAP>.
+
+=cut
+
+sub object_table { 'team' }
+
+sub key_field { 'name' }
+
+sub has_extended_attributes { 1 }
+
+sub _initial_fields {
+    my ($self, $for) = @_;
+    {
+        name => 'name',
+    }
+}
+
+sub _inline_fields {
+    my ($self, $for) = @_;
+
+    my %fields = (
+        %{ $self->_initial_fields($for) },
+    );
+    \%fields;
+}
+
+sub _delayed_fields {
+    my ($self)= @_;
+    return qw();
+}
+
+1;
+
+__END__
+
+=head1 SEE ALSO
+
+=head1 AUTHOR
+
+Olivier Thauvin, E<lt>olivier.thauvin@latmos.ipsl.frE<gt>
+
+=head1 COPYRIGHT AND LICENSE
+
+Copyright (C) 2008, 2009 CNRS SA/CETP/LATMOS
+
+This library is free software; you can redistribute it and/or modify
+it under the same terms as Perl itself, either Perl version 5.10.0 or,
+at your option, any later version of Perl 5 you may have available.
+
+
+=cut