Index: /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Model/AttrForms.pm
===================================================================
--- /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Model/AttrForms.pm	(revision 150)
+++ /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Model/AttrForms.pm	(revision 151)
@@ -19,4 +19,5 @@
     uidNumber => [ 'UID' ],
     gidNumber => [ 'GID', 'select:group:gidNumber' ],
+    manager => [ 'Responsable', 'select-N:user:uid' ],
     sn => [ 'Nom' ],
     givenName => [ 'PrÃ©nom' ],
@@ -30,5 +31,5 @@
     postalCode => [ 'Code postal' ],
     postOfficeBox => [ 'BP' ],
-    department => [ 'DÃ©partement' ],
+    department => [ 'DÃ©partement', 'select-N:department' ],
     streetAddress => [ 'Rue', 'textarea' ],
     st => [ 'Etat' ],
@@ -64,4 +65,5 @@
         attrs => [ qw(
             company
+            manager
             department
             title
@@ -80,9 +82,9 @@
     cell => {
         name => 'Cellule',
-        attrs => [qw(description) ],
+        attrs => [qw(description manager) ],
     },
     department => {
         name => 'DÃ©partement',
-        attrs => [qw(description) ],
+        attrs => [qw(description manager) ],
     },
     team => {
@@ -178,10 +180,12 @@
             $self->attr_raw_value($attr)
         );
-        /^select:([^:]+):(.*)$/ and do {
-            my $otype = $1;
-            my $keyfield = $2;
+        /^select(-\w+)?:([^:]+)(?::(.*))?$/ and do {
+            my $options = $1 || '';
+            my $otype = $2;
+            my $keyfield = $3;
             my $select = sprintf('<select name="%s">',
                 $self->escape($attr)) . "\n";
-            my $value = $self->attr_raw_value($attr);
+            $select .= '<option value="">--</option>' . "\n" if ($options =~ /N/);
+            my $value = $self->attr_raw_value($attr) || '';
             foreach my $id ($self->base->list_objects($otype)) {
                 my $obj = $self->base->get_object($otype, $id) or next;
Index: /LATMOS-Accounts-Web/root/html/cells/index.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/cells/index.tt	(revision 150)
+++ /LATMOS-Accounts-Web/root/html/cells/index.tt	(revision 151)
@@ -31,4 +31,7 @@
 
 <table border="0">
+<table border="0">
+<tr><td colspan="2">[% cellslist.size %] Cellules</td></tr>
+<tr><th>Nom</th><th>Description</th></tr>
 [% FOREACH cellname = cellslist %]
 [% cell = db.get_object('cell', cellname) %]
@@ -36,5 +39,5 @@
     <td>[% cell.get_c_field('name') | html %]</td>
     <td>
-        [% cell.get_c_field('l') | html %]
+        [% cell.get_c_field('description') | truncate(30) | html %]
     <a href="[% c.uri_for('/cells', cellname) %]">
         <img src="[% c.uri_for('/static', 'icons', 'arrow-right.png') %]"
Index: /LATMOS-Accounts-Web/root/html/departments/index.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/departments/index.tt	(revision 150)
+++ /LATMOS-Accounts-Web/root/html/departments/index.tt	(revision 151)
@@ -31,4 +31,7 @@
 
 <table border="0">
+<table border="0">
+<tr><td colspan="2">[% departmentslist.size %] DÃ©partements</td></tr>
+<tr><th>Nom</th><th>Description</th></tr>
 [% FOREACH departmentname = departmentslist %]
 [% department = db.get_object('department', departmentname) %]
@@ -36,5 +39,5 @@
     <td>[% department.get_c_field('name') | html %]</td>
     <td>
-        [% department.get_c_field('l') | html %]
+        [% department.get_c_field('description') | truncate(30) | html %]
     <a href="[% c.uri_for('/departments', departmentname) %]">
         <img src="[% c.uri_for('/static', 'icons', 'arrow-right.png') %]"
Index: /LATMOS-Accounts-Web/root/html/includes/header.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/includes/header.tt	(revision 150)
+++ /LATMOS-Accounts-Web/root/html/includes/header.tt	(revision 151)
@@ -21,4 +21,7 @@
     <p><a href="[% c.uri_for('/users') %]">Utilisateurs</a></p>
     <p><a href="[% c.uri_for('/groups') %]">Groupes</a></p>
+    <p><a href="[% c.uri_for('/departments') %]">DÃ©partement</a></p>
+    <p><a href="[% c.uri_for('/teams') %]">Ãquipes</a></p>
+    <p><a href="[% c.uri_for('/cells') %]">Cellules</a></p>
     <p><a href="[% c.uri_for('/sites') %]">Sites</a></p>
 </div>
Index: /LATMOS-Accounts-Web/root/html/sites/index.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/sites/index.tt	(revision 150)
+++ /LATMOS-Accounts-Web/root/html/sites/index.tt	(revision 151)
@@ -31,4 +31,7 @@
 
 <table border="0">
+<table border="0">
+<tr><td colspan="2">[% siteslist.size %] Sites</td></tr>
+<tr><th>Nom</th><th>Ville</th></tr>
 [% FOREACH sitename = siteslist %]
 [% site = db.get_object('site', sitename) %]
Index: /LATMOS-Accounts-Web/root/html/teams/index.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/teams/index.tt	(revision 150)
+++ /LATMOS-Accounts-Web/root/html/teams/index.tt	(revision 151)
@@ -31,4 +31,7 @@
 
 <table border="0">
+<table border="0">
+<tr><td colspan="2">[% teamslist.size %] Ãquipes</td></tr>
+<tr><th>Nom</th><th>Description</th></tr>
 [% FOREACH teamname = teamslist %]
 [% team = db.get_object('team', teamname) %]
@@ -36,5 +39,5 @@
     <td>[% team.get_c_field('name') | html %]</td>
     <td>
-        [% team.get_c_field('l') | html %]
+        [% team.get_c_field('description') | truncate(30) | html %]
     <a href="[% c.uri_for('/teams', teamname) %]">
         <img src="[% c.uri_for('/static', 'icons', 'arrow-right.png') %]"