Index: TMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Cells.pm
===================================================================
--- /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Cells.pm	(revision 164)
+++ 	(revision )
@@ -1,67 +1,0 @@
-package LATMOS::Accounts::Web::Controller::Cells;
-
-use strict;
-use warnings;
-use base 'LATMOS::Accounts::Web::Controller';
-
-=head1 NAME
-
-LATMOS::Accounts::Web::Controller::Site - Catalyst Controller
-
-=head1 DESCRIPTION
-
-Catalyst Controller.
-
-=head1 METHODS
-
-=cut
-
-
-=head2 index 
-
-=cut
-
-sub index : Private {
-    my ( $self, $c ) = @_;
-
-    my $base = $c->model('Accounts')->db;
-    my %filter = map  {
-        $c->req->params->{attr}[$_] && $c->req->params->{attrval}[$_]
-        ? ($c->req->params->{attr}[$_] => $c->req->params->{attrval}[$_])
-        : ()
-    } (0 .. $#{ $c->req->params->{attr} || []});
-    $c->stash->{cellslist} = %filter
-        ? [ $base->search_objects('cell', %filter) ]
-        : [ $base->list_objects('cell') ];
-}
-
-sub default : LocalPath {
-    my ( $self, $c, undef, $cellname, $subform ) = @_;
-
-    my $base = $c->model('Accounts')->db;
-
-    $c->stash->{cellname} = $cellname;
-    $c->stash->{cell} = $base->get_object('cell', $cellname);
-    $c->stash->{subform} = $subform || '';
-
-    for ($subform) {
-        # Exceptions...
-        # /^$/ $c->stash->{template} =
-
-        $c->stash->{form} = $c->model('AttrForms', 'cell' . $c->stash->{subform}, $c->stash->{cell});
-        $c->stash->{form}->set_attrs;
-    }
-}
-
-=head1 AUTHOR
-
-Thauvin Olivier
-
-=head1 LICENSE
-
-This library is free software, you can redistribute it and/or modify
-it under the same terms as Perl itself.
-
-=cut
-
-1;
Index: /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Groups.pm
===================================================================
--- /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Groups.pm	(revision 164)
+++ /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Groups.pm	(revision 165)
@@ -44,5 +44,5 @@
     $c->stash->{subform} = $subform || '';
 
-    for ($subform) {
+    for ($subform || '') {
         # Exceptions...
         /^users$/ and do {
Index: TMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Teams.pm
===================================================================
--- /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Teams.pm	(revision 164)
+++ 	(revision )
@@ -1,67 +1,0 @@
-package LATMOS::Accounts::Web::Controller::Teams;
-
-use strict;
-use warnings;
-use base 'LATMOS::Accounts::Web::Controller';
-
-=head1 NAME
-
-LATMOS::Accounts::Web::Controller::Site - Catalyst Controller
-
-=head1 DESCRIPTION
-
-Catalyst Controller.
-
-=head1 METHODS
-
-=cut
-
-
-=head2 index 
-
-=cut
-
-sub index : Private {
-    my ( $self, $c ) = @_;
-
-    my $base = $c->model('Accounts')->db;
-    my %filter = map  {
-        $c->req->params->{attr}[$_] && $c->req->params->{attrval}[$_]
-        ? ($c->req->params->{attr}[$_] => $c->req->params->{attrval}[$_])
-        : ()
-    } (0 .. $#{ $c->req->params->{attr} || []});
-    $c->stash->{teamslist} = %filter
-        ? [ $base->search_objects('team', %filter) ]
-        : [ $base->list_objects('team') ];
-}
-
-sub default : LocalPath {
-    my ( $self, $c, undef, $teamname, $subform ) = @_;
-
-    my $base = $c->model('Accounts')->db;
-
-    $c->stash->{teamname} = $teamname;
-    $c->stash->{team} = $base->get_object('team', $teamname);
-    $c->stash->{subform} = $subform || '';
-
-    for ($subform) {
-        # Exceptions...
-        # /^$/ $c->stash->{template} =
-
-        $c->stash->{form} = $c->model('AttrForms', 'team' . $c->stash->{subform}, $c->stash->{team});
-        $c->stash->{form}->set_attrs;
-    }
-}
-
-=head1 AUTHOR
-
-Thauvin Olivier
-
-=head1 LICENSE
-
-This library is free software, you can redistribute it and/or modify
-it under the same terms as Perl itself.
-
-=cut
-
-1;
Index: /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Model/AttrForms.pm
===================================================================
--- /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Model/AttrForms.pm	(revision 164)
+++ /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Model/AttrForms.pm	(revision 165)
@@ -36,5 +36,6 @@
     title => [ 'Fonction' ],
     expire => [ 'Expire le', 'date' ],
-    st => [ 'Ãtat (US)' ]
+    st => [ 'Ãtat (US)' ],
+    sutype => [ 'Structure admin.', 'select-N:sutype' ],
 };
 
@@ -85,16 +86,8 @@
         ) ],
     },
-    cell => {
-        name => 'Cellule',
-        attrs => [qw(description manager) ],
-    },
     department => {
         name => 'DÃ©partement',
         attrs => [qw(description manager) ],
     },
-    team => {
-        name => 'Ãquipe',
-        attrs => [qw(description) ],
-    },
     group => {
         name => 'SystÃšme',
@@ -102,4 +95,5 @@
         attrs => [ qw(
             gidNumber description
+            sutype
         ) ],
     },
@@ -175,5 +169,5 @@
     # exception: gidNumber is used also in group, but we don't want
     # group list here, really the number !
-    $type = '' if (($self->{form} || '') =~ /^group/);
+    $type = '' if (($self->{form} || '') =~ /^group/ && $attr eq 'gidNumber');
     for ($type) {
         /^textarea$/ and return sprintf(
Index: /LATMOS-Accounts-Web/root/html/includes/header.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/includes/header.tt	(revision 164)
+++ /LATMOS-Accounts-Web/root/html/includes/header.tt	(revision 165)
@@ -20,6 +20,4 @@
     <p><a href="[% c.uri_for('/groups') %]">Groupes</a></p>
     <p><a href="[% c.uri_for('/departments') %]">DÃ©partement</a></p>
-    <p><a href="[% c.uri_for('/teams') %]">Ãquipes</a></p>
-    <p><a href="[% c.uri_for('/cells') %]">Cellules</a></p>
     <p><a href="[% c.uri_for('/sites') %]">Sites</a></p>
 </div>
Index: /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Sutype.pm
===================================================================
--- /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Sutype.pm	(revision 165)
+++ /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Sutype.pm	(revision 165)
@@ -0,0 +1,69 @@
+package LATMOS::Accounts::Bases::Sql::Sutype;
+
+use 5.010000;
+use strict;
+use warnings;
+
+use base qw(LATMOS::Accounts::Bases::Sql::objects);
+
+our $VERSION = (q$Rev$ =~ /^Rev: (\d+) /)[0];
+
+=head1 NAME
+
+LATMOS::Ad - Perl extension for blah blah blah
+
+=head1 SYNOPSIS
+
+  use LATMOS::Accounts::Bases;
+  my $base = LATMOS::Accounts::Bases->new('sql');
+  ...
+
+=head1 DESCRIPTION
+
+Account base access over standard unix file format.
+
+=head1 FUNCTIONS
+
+=cut
+
+=head2 new(%options)
+
+Create a new LATMOS::Ad object for windows AD $domain.
+
+domain / server: either the Ad domain or directly the server
+
+ldap_args is an optionnal list of arguments to pass to L<Net::LDAP>.
+
+=cut
+
+sub object_table { 'su_type' }
+
+sub key_field { 'name' }
+
+sub has_extended_attributes { 0 }
+
+sub _delayed_fields {
+    my ($self)= @_;
+    return qw();
+}
+
+1;
+
+__END__
+
+=head1 SEE ALSO
+
+=head1 AUTHOR
+
+Olivier Thauvin, E<lt>olivier.thauvin@latmos.ipsl.frE<gt>
+
+=head1 COPYRIGHT AND LICENSE
+
+Copyright (C) 2008, 2009 CNRS SA/CETP/LATMOS
+
+This library is free software; you can redistribute it and/or modify
+it under the same terms as Perl itself, either Perl version 5.10.0 or,
+at your option, any later version of Perl 5 you may have available.
+
+
+=cut
Index: TMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Team.pm
===================================================================
--- /LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Team.pm	(revision 164)
+++ 	(revision )
@@ -1,69 +1,0 @@
-package LATMOS::Accounts::Bases::Sql::Team;
-
-use 5.010000;
-use strict;
-use warnings;
-
-use base qw(LATMOS::Accounts::Bases::Sql::objects);
-
-our $VERSION = (q$Rev$ =~ /^Rev: (\d+) /)[0];
-
-=head1 NAME
-
-LATMOS::Ad - Perl extension for blah blah blah
-
-=head1 SYNOPSIS
-
-  use LATMOS::Accounts::Bases;
-  my $base = LATMOS::Accounts::Bases->new('sql');
-  ...
-
-=head1 DESCRIPTION
-
-Account base access over standard unix file format.
-
-=head1 FUNCTIONS
-
-=cut
-
-=head2 new(%options)
-
-Create a new LATMOS::Ad object for windows AD $domain.
-
-domain / server: either the Ad domain or directly the server
-
-ldap_args is an optionnal list of arguments to pass to L<Net::LDAP>.
-
-=cut
-
-sub object_table { 'team' }
-
-sub key_field { 'name' }
-
-sub has_extended_attributes { 1 }
-
-sub _delayed_fields {
-    my ($self)= @_;
-    return qw();
-}
-
-1;
-
-__END__
-
-=head1 SEE ALSO
-
-=head1 AUTHOR
-
-Olivier Thauvin, E<lt>olivier.thauvin@latmos.ipsl.frE<gt>
-
-=head1 COPYRIGHT AND LICENSE
-
-Copyright (C) 2008, 2009 CNRS SA/CETP/LATMOS
-
-This library is free software; you can redistribute it and/or modify
-it under the same terms as Perl itself, either Perl version 5.10.0 or,
-at your option, any later version of Perl 5 you may have available.
-
-
-=cut