Index: /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller.pm
===================================================================
--- /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller.pm	(revision 213)
+++ /LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller.pm	(revision 214)
@@ -24,4 +24,21 @@
     my ( $self, $c ) = @_;
 
+    my $menu = '';
+    my @menus = (
+        [ 'users' => 'Utilisateurs' ],
+        [ 'create/user' => 'CrÃ©er un Utilisateurs' ],
+        [ 'groups' => 'Groupes' ],
+        [ 'sites' => 'Sites' ],
+    );
+    foreach(@menus) {
+        $menu .= sprintf(
+            q{<a href="%s"><span%s>%s</span></a>},
+            $c->uri_for('/' . $_->[0]),
+            ($c->req->path =~ m:^$_->[0]: ? ' id="actif"' : ''),
+            $_->[1],
+        );
+
+    }
+    $c->stash->{mainmenu} = $menu;
 }
 
Index: /LATMOS-Accounts-Web/root/html/groups/default.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/groups/default.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/groups/default.tt	(revision 214)
@@ -4,5 +4,5 @@
 [% ELSE %]
     
-<div class=objectform>
+<div class="objectform" id="objectform">
 [% INCLUDE 'groups/menu.tt' %]
 
@@ -11,3 +11,4 @@
     form_uri = c.uri_for(groupname, subform) %]
 </div>
+</div>
 [% END %]
Index: /LATMOS-Accounts-Web/root/html/groups/menu.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/groups/menu.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/groups/menu.tt	(revision 214)
@@ -1,4 +1,4 @@
 <!-- $Id$ -->
-<div>
+<div id="omenu">
     <table border="0">
     <tr><td>
@@ -8,9 +8,6 @@
     <td>   
     [% groupname | html %]<br>
-    </td></tr>
-    <tr><td colspan=2>
-        <a href="[% c.uri_for(groupname) %]">SystÃšme</a> ::
-        <a href="[% c.uri_for(groupname, 'users') %]">Utilisateurs</a>
-    </td></tr>
     </table>
+        <a href="[% c.uri_for(groupname) %]"><span [% 'id="oactive"' IF subform == '' %]>SystÃšme</span></a>
+        <a href="[% c.uri_for(groupname, 'users') %]"><span [% 'id="oactive"' IF subform == '' %]>Utilisateurs</span></a>
 </div>
Index: /LATMOS-Accounts-Web/root/html/groups/users.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/groups/users.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/groups/users.tt	(revision 214)
@@ -7,4 +7,5 @@
 [% INCLUDE 'groups/menu.tt' %]
 
+<div id="oform">
 <table border=1>
 <tr><th>Membres</th></tr>
@@ -19,4 +20,5 @@
 [% END %]
 </table>
+</div>
 
 </div>
Index: /LATMOS-Accounts-Web/root/html/includes/form.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/includes/form.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/includes/form.tt	(revision 214)
@@ -2,4 +2,5 @@
 [% FOREACH attr =  form.attributes %]
 [% IF loop.first %]
+<div id="oform">
 <form action="[% form_uri | html %]" method="POST">
 <table border=1>
@@ -13,4 +14,5 @@
 </table>
 </form>
+</div>
 [% END %]
 [% END %]
Index: /LATMOS-Accounts-Web/root/html/includes/header.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/includes/header.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/includes/header.tt	(revision 214)
@@ -15,10 +15,5 @@
     Gestion des Utilisateurs du LATMOS
 </div>
-
-<div style="float: left" id="mainmenu" class="pmenu">
-    <p><a href="[% c.uri_for('/users') %]">Utilisateurs</a></p>
-    <p><a href="[% c.uri_for('/create/user') %]">CrÃ©er un Utilisateurs</a></p>
-    <p><a href="[% c.uri_for('/groups') %]">Groupes</a></p>
-    <p><a href="[% c.uri_for('/departments') %]">DÃ©partement</a></p>
-    <p><a href="[% c.uri_for('/sites') %]">Sites</a></p>
+<div id="mainmenu" class="pmenu">
+    [% mainmenu %]
 </div>
Index: /LATMOS-Accounts-Web/root/html/sites/default.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/sites/default.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/sites/default.tt	(revision 214)
@@ -4,5 +4,5 @@
 [% ELSE %]
     
-<div class=objectform>
+<div class="objectform" id="objectform">
 [% INCLUDE 'sites/menu.tt' %]
 
Index: /LATMOS-Accounts-Web/root/html/sites/menu.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/sites/menu.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/sites/menu.tt	(revision 214)
@@ -1,4 +1,4 @@
 <!-- $Id: user_menu.tt 443 2009-05-18 03:52:21Z nanardon $ -->
-<div>
+<div id="omenu">
     <table border="0">
     <tr><td>
@@ -10,9 +10,4 @@
     [% user.get_c_field('l') | html %]
     </td></tr>
-    <!--
-    <tr><td colspan=2>
-        <a href="[% c.uri_for(sitename) %]">SystÃšme</a>
-    </td></tr>
-    -->
     </table>
 </div>
Index: /LATMOS-Accounts-Web/root/html/users/default.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/users/default.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/users/default.tt	(revision 214)
@@ -4,5 +4,5 @@
 [% ELSE %]
     
-<div class=objectform>
+<div id="objectform" class="objectform">
 [% INCLUDE 'users/menu.tt' %]
 
Index: /LATMOS-Accounts-Web/root/html/users/groups.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/users/groups.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/users/groups.tt	(revision 214)
@@ -4,7 +4,8 @@
 [% ELSE %]
     
-<div class=objectform>
+<div id="objectform" class="objectform">
 [% INCLUDE 'users/menu.tt' %]
 
+<div id="oform">
 <table border="1">
 <tr>
@@ -35,3 +36,4 @@
 
 </div>
+</div>
 [% END %]
Index: /LATMOS-Accounts-Web/root/html/users/menu.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/users/menu.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/users/menu.tt	(revision 214)
@@ -1,21 +1,19 @@
 <!-- $Id$ -->
-<div>
-    <table border="0">
-    <tr><td>
-    <img src="[% c.uri_for('/static', 'icons', 'user-properties.png') %]"
-    alt="[% "User " _ username %]">
-    </td>
-    <td>   
-    [% username | html %]<br>
-    [% user.get_c_field('sn') | html %]
-    [% user.get_c_field('givenName') | html %]
-    </td></tr>
-    <tr><td colspan=2>
-        <a href="[% c.uri_for(username) %]">SystÃšme</a> ::
-        <a href="[% c.uri_for(username, 'address') %]">Adresse</a> ::
-        <a href="[% c.uri_for(username, 'status') %]">Status</a> ::
-        <a href="[% c.uri_for(username, 'groups') %]">Groupes</a> ::
-        <a href="[% c.uri_for(username, 'passwd') %]">Mot de passe</a>
-    </td></tr>
-    </table>
+<div id="omenu">
+<table border="0">
+<tr><td>
+<img src="[% c.uri_for('/static', 'icons', 'user-properties.png') %]"
+alt="[% "User " _ username %]">
+</td>
+<td>   
+[% username | html %]<br>
+[% user.get_c_field('sn') | html %]
+[% user.get_c_field('givenName') | html %]
+</td></tr>
+</table>
+        <a href="[% c.uri_for(username) %]"><span [% 'id="oactive"' IF subform == '' %]>SystÃšme</span></a>
+        <a href="[% c.uri_for(username, 'address') %]"><span [% 'id="oactive"' IF subform == 'address' %]>Adresse</span></a>
+        <a href="[% c.uri_for(username, 'status') %]"><span [% 'id="oactive"' IF subform == 'status' %]>Status</span></a>
+        <a href="[% c.uri_for(username, 'groups') %]"><span [% 'id="oactive"' IF subform == 'groups' %]>Groupes</span></a>
+        <a href="[% c.uri_for(username, 'passwd') %]"><span [% 'id="oactive"' IF subform == 'passwd' %]>Mot de passe</span></a>
 </div>
Index: /LATMOS-Accounts-Web/root/html/users/passwd.tt
===================================================================
--- /LATMOS-Accounts-Web/root/html/users/passwd.tt	(revision 213)
+++ /LATMOS-Accounts-Web/root/html/users/passwd.tt	(revision 214)
@@ -4,7 +4,8 @@
 [% ELSE %]
     
-<div class=objectform>
+<div id="objectform" class="objectform">
 [% INCLUDE 'users/menu.tt' %]
 
+<div id="oform">
 <form action="[% c.uri_for(username, subform) %]" method="POST">
 <table border="1">
@@ -30,3 +31,4 @@
 </form>
 </div>
+</div>
 [% END %]
Index: /LATMOS-Accounts-Web/root/static/style.css
===================================================================
--- /LATMOS-Accounts-Web/root/static/style.css	(revision 213)
+++ /LATMOS-Accounts-Web/root/static/style.css	(revision 214)
@@ -2,4 +2,9 @@
     border: none;
     vertical-align: middle;
+}
+
+.pmenu {
+    background-color: #7DB4D8;
+    padding: 0.5em;
 }
 
@@ -8,10 +13,70 @@
 }
 
-#mainmenu {
+#mainmenu a {
     font-size: 80%;
+    overflow: hidden;
+    text-decoration: none;
 }
 
-.pmenu {
-    background-color: #6666CC;
-    padding: 0.5em;
+#mainmenu span {
+    border-style: outset;
+    padding-left: 1em;
+    padding-right: 1em;
+    text-decoration: none;
 }
+
+#mainmenu span#actif {
+    border-style: inset;
+    border-size: 1px;
+    padding-left: 1em;
+    padding-right: 1em;
+    text-decoration: none;
+}
+
+.objectform {
+    border-style: outset;
+    margin-left: 20%;
+    margin-right: 20%;
+}
+
+#objectform table {
+    margin: 1em;
+}
+
+#omenu a:hover {
+}
+
+#omenu a {
+    text-decoration: none;
+}
+
+#omenu td {
+    padding-left: 0.5em;
+    padding-right: 0.5em;
+}
+
+#omenu span {
+    padding-left: 1em;
+    padding-right: 1em;
+    margin: 0;
+    border: groove thin;
+    text-decoration: none;
+}
+
+#omenu span#oactive {
+    margin: 0;
+    padding-left: 1em;
+    padding-right: 1em;
+    border: outset;
+    border-bottom-style: none;
+    text-decoration: none;
+}
+
+#oform {
+    border: inset;
+}
+
+#oform table {
+    margin-left: 20%;
+    margin-right: 20%;
+}