Index: /LATMOS-Accounts/MANIFEST
===================================================================
--- /LATMOS-Accounts/MANIFEST	(revision 479)
+++ /LATMOS-Accounts/MANIFEST	(revision 480)
@@ -7,5 +7,4 @@
 annexes/sql.schema.sql
 bin/la-acls
-bin/la-attributes
 bin/la-config
 bin/la-create
Index: TMOS-Accounts/bin/la-qacls
===================================================================
--- /LATMOS-Accounts/bin/la-qacls	(revision 479)
+++ 	(revision )
@@ -1,65 +1,0 @@
-#!/usr/bin/perl
-
-use strict;
-use warnings;
-use LATMOS::Accounts;
-use Getopt::Long;
-use Pod::Usage;
-use Term::ReadKey;
-
-=head1 NAME
-
-    la-config - Tools to query configuration of LATMOS::Accounts system.
-
-=head1 SYNOPSIS
-
-List supported base, synchronisation, objects and attributes
-
-    la-config [option] [object]
-
-=cut
-
-GetOptions(
-    'c|config=s' => \my $config,
-    'base=s'     => \my $base,
-    'o|object=s' => \my $otype,
-    'u|user=s'   => \my $user,
-    'help'       => sub { pod2usage(0) },
-) or pod2usage();
-
-$otype ||= 'user';
-
-=head1 OPTIONS
-
-=item -c|--config configfile
-
-Use this configuration file instead default
-
-=item -b|--base basename
-
-Perform query on this base
-
-=cut
-
-my $LA = LATMOS::Accounts->new($config, noacl => 0);
-
-my $labase = $base ? $LA->base($base) : $LA->default_base;
-
-if ($user) {
-    $labase->{_user} = $user;
-}
-
-my $obj = $ARGV[0] ? $labase->get_object($otype, $ARGV[0]) : $otype
-    or die "No object $otype $ARGV[0]";
-
-
-printf("%s%s %s\n",
-    ($labase->check_acl($obj, $_, 'w') ? 'w' : ' '),
-    $_,
-) foreach(qw(@CREATE @DELETE));
-
-printf("%s%s %s\n",
-    ($labase->check_acl($obj, $_, 'r') ? 'r' : ' '),
-    ($labase->check_acl($obj, $_, 'w') ? 'w' : ' '),
-    $_,
-) foreach($labase->list_canonical_fields($otype, 'a'));
Index: /LATMOS-Accounts/lib/LATMOS/Accounts/Acls.pm
===================================================================
--- /LATMOS-Accounts/lib/LATMOS/Accounts/Acls.pm	(revision 479)
+++ /LATMOS-Accounts/lib/LATMOS/Accounts/Acls.pm	(revision 480)
@@ -33,7 +33,7 @@
 enclose into bracket, either a '*' to match any attribute.
 
-Special keyword C<@CREATE> and C<@DELETE> can be used to allow or deny object
+Special keyword C<CREATE> and C<DELETE> can be used to allow or deny object
 creation and deletion. In this case USER in form C<$...> and read permission
-have no effect (see below). C<*> do not include C<@CREATE> and C<@DELETE> action.
+have no effect (see below). C<*> do not include C<CREATE> and C<DELETE> action.
 
 =item USER can be
@@ -127,7 +127,4 @@
 sub check {
     my ($self, $obj, $attr, $perm, $who, $groups) = @_;
-    # Asking 'r' perm over create or delete has no sense:
-    $attr =~ /^@(CREATE|DELETE)$/ && $perm eq 'r' and return;
-
     foreach my $acl (@{$self->{_acls}}) {
         my $res = $acl->match($obj, $attr, $perm, $who, $groups);
@@ -191,15 +188,10 @@
     my $objtype = ref $obj ? lc($obj->type) : $obj;
     $attr = lc($attr);
-
-    # Does this ACL series concern this object:
     if (!($self->{obj} eq '*' || $self->{obj} eq $objtype)) {
         return
     }
-    # Does this ACL series concern this attribute:
-    grep { ($_ !~ /^@(CREATE|DELETE)$/ && $_ eq '*') || $_ eq $attr } @{$self->{attr}} or return;
-
-    # Foreach user, testing if this permission match:
+    grep { ($_ !~ /^(CREATE|DELETE)$/ && $_ eq '*') || $_ eq $attr } @{$self->{attr}} or return;
+
     foreach my $u (@{ $self->{users} }) {
-        # Obj have attr eq login user
         if (substr($u->{user}, 0, 1) eq '$') { # check attr content
             if (ref $obj) {
@@ -209,15 +201,11 @@
                 return ($u->{$perm} || 0) if (grep { $_ eq $who } @vals);
             }
-        # user is in group
         } elsif (substr($u->{user}, 0, 1) eq '%') { # group
             my $group = substr($u->{user}, 1);
             return ($u->{$perm} || 0) if (grep { $group eq $_ } @{$groups ||[]});
-        # any user
         } elsif ($u->{user} eq '*' || $u->{user} eq $who) {
             return $u->{$perm} || 0;
-        # any authenticated user
         } elsif (lc($u->{user}) eq '@authenticated' && $who) {
             return $u->{$perm} || 0;
-        # not login
         } elsif (lc($u->{user}) eq '@anonymous' && $who eq "") {
             return $u->{$perm} || 0;