Index: /LATMOS-Accounts/bin/la-cli
===================================================================
--- /LATMOS-Accounts/bin/la-cli	(revision 848)
+++ /LATMOS-Accounts/bin/la-cli	(revision 849)
@@ -10,25 +10,18 @@
 =head1 NAME
 
-    la-query - Tools to query base in LATMOS::Accounts system
+    la-cli - A powerfull commandline tool to manage LATMOS::Accounts contents
 
 =head1 SYNOPSIS
 
-    la-query [options] [obj_id]
-
-=item [obj_id] : If present, all set attributes (rw) will be displayed for that obj_id.
-        If none is given, all obj_ids will be printed.
-
-For the default object_type (user), obj_id = login.
-
-Example : la-query lambda
+    la-cli [options]
 
 =cut
 
 GetOptions(
-    'c|config=s' => \my $config,
-    'b|base=s'   => \my $base,
-    'noexp'      => \my $noexp,
-    'exp'        => \my $exp,
-    'help'       => sub { pod2usage(0) },
+    'c|config=s'        => \my $config,
+    'b|base=s'          => \my $base,
+    'no-unexp|wo-unexp' => \my $nounexp,
+    'with-unexp'        => \my $unexp,
+    'help'              => sub { pod2usage(0) },
 ) or pod2usage();
 
@@ -45,9 +38,9 @@
 Query this specific base instead of the default one.
 
-=item --noexp
+=item --unexp
 
 Take into account all objects (even non propagated ones, with attribute 'exported'=0)
 
-=item --exp
+=item --no-unexp
 
 Take into account only propagated objects (attribute 'exported'=1) (default)
@@ -61,5 +54,5 @@
 $labase && $labase->load or die "Cannot load base";
 
-$labase->wexported($noexp ? 0 : 1);
+$labase->unexported($nounexp ? 0 : 1);
 
 my $globalenv = LATMOS::Accounts::Cli::globalenv($labase);
Index: /LATMOS-Accounts/bin/la-group
===================================================================
--- /LATMOS-Accounts/bin/la-group	(revision 848)
+++ /LATMOS-Accounts/bin/la-group	(revision 849)
@@ -20,11 +20,11 @@
 
 GetOptions(
-    'c|config=s' => \my $config,
-    'b|base=s'   => \my $base,
-    's'          => \my $set,
-    'r'          => \my $remove,
-    'noexp'      => \my $noexp,
-    'exp'        => \my $exp,
-    'help'       => sub { pod2usage(0) },
+    'c|config=s'        => \my $config,
+    'b|base=s'          => \my $base,
+    's'                 => \my $set,
+    'r'                 => \my $remove,
+    'no-unexp|wo-unexp' => \my $nounexp,
+    'with-unexp'        => \my $unexp,
+    'help'              => sub { pod2usage(0) },
 ) or pod2usage();
 
@@ -49,11 +49,12 @@
 Query this specific base instead of the default one.
 
-=item --noexp
+=item --with-unexp
 
-Take into account all objects (even non propagated ones, with attribute 'exported'=0)
+Take into account all objects (even non propagated ones, with attribute
+'exported'=0) (default)
 
-=item --exp
+=item --wo-unexp
 
-Take into account only propagated objects (attribute 'exported'=1) (default)
+Take into account only propagated objects (attribute 'exported'=1)
 
 =item -r
@@ -75,5 +76,5 @@
 $labase && $labase->load or die "Cannot load base";
 
-$labase->wexported($noexp ? 0 : 1);
+$labase->unexported($nounexp ? 0 : 1);
 
 $labase->is_supported_object($otype) or die "$otype object unsupported\n";
Index: /LATMOS-Accounts/bin/la-guser
===================================================================
--- /LATMOS-Accounts/bin/la-guser	(revision 848)
+++ /LATMOS-Accounts/bin/la-guser	(revision 849)
@@ -20,11 +20,11 @@
 
 GetOptions(
-    'c|config=s' => \my $config,
-    'b|base=s'   => \my $base,
-    's'          => \my $set,
-    'r'          => \my $remove,
-    'noexp'      => \my $noexp,
-    'exp'        => \my $exp,
-    'help'       => sub { pod2usage(0) },
+    'c|config=s'        => \my $config,
+    'b|base=s'          => \my $base,
+    's'                 => \my $set,
+    'r'                 => \my $remove,
+    'no-unexp|wo-unexp' => \my $nounexp,
+    'with-exp'          => \my $unexp,
+    'help'              => sub { pod2usage(0) },
 ) or pod2usage();
 
@@ -49,11 +49,12 @@
 Query this specific base instead of the default one.
 
-=item --noexp
+=item --with-unexp
 
-Take into account all objects (even non propagated ones, with attribute 'exported'=0)
+Take into account all objects (even non propagated ones, with attribute
+'exported'=0) (default)
 
-=item --exp
+=item --wo-unexp
 
-Take into account only propagated objects (attribute 'exported'=1) (default)
+Take into account only propagated objects (attribute 'exported'=1)
 
 =item -r
@@ -75,5 +76,5 @@
 $labase && $labase->load or die "Cannot load base";
 
-$labase->wexported($noexp ? 0 : 1);
+$labase->unexported($nounexp ? 0 : 1);
 
 $labase->is_supported_object($otype) or die "$otype object unsupported\n";
Index: /LATMOS-Accounts/bin/la-qacls
===================================================================
--- /LATMOS-Accounts/bin/la-qacls	(revision 848)
+++ /LATMOS-Accounts/bin/la-qacls	(revision 849)
@@ -23,11 +23,11 @@
 
 GetOptions(
-    'c|config=s' => \my $config,
-    'b|base=s'     => \my $base,
-    'o|object=s' => \my $otype,
-    'u|user=s'   => \my $user,
-    'noexp'      => \my $noexp,
-    'exp'        => \my $exp,
-    'help'       => sub { pod2usage(0) },
+    'c|config=s'        => \my $config,
+    'b|base=s'          => \my $base,
+    'o|object=s'        => \my $otype,
+    'u|user=s'          => \my $user,
+    'no-unexp|wo-unexp' => \my $nounexp,
+    'exp'               => \my $unexp,
+    'help'              => sub { pod2usage(0) },
 ) or pod2usage();
 
@@ -44,9 +44,9 @@
 Query this specific base instead of the default one.
 
-=item --noexp
+=item --with-unexp
 
 Take into account all objects (even non propagated ones, with attribute 'exported'=0)
 
-=item --exp
+=item --wo-unexp
 
 Take into account only propagated objects (attribute 'exported'=1) (default)
@@ -66,5 +66,5 @@
 my $labase = $base ? $LA->base($base) : $LA->default_base;
 
-$labase->wexported($noexp ? 0 : 1);
+$labase->unexported($unexp ? 1 : 0);
 
 if ($user) {
Index: /LATMOS-Accounts/bin/la-query
===================================================================
--- /LATMOS-Accounts/bin/la-query	(revision 848)
+++ /LATMOS-Accounts/bin/la-query	(revision 849)
@@ -25,14 +25,14 @@
 
 GetOptions(
-    'c|config=s' => \my $config,
-    'b|base=s'   => \my $base,
-    'o|object=s' => \my $otype,
-    'e|empty'    => \my $empty_attr,
-    'fmt=s'      => \my $fmt,
-    'filefmt=s'  => \my $filefmt,
-    'ro'         => \my $with_ro,
-    'noexp'      => \my $noexp,
-    'exp'        => \my $exp,
-    'help'       => sub { pod2usage(0) },
+    'c|config=s'        => \my $config,
+    'b|base=s'          => \my $base,
+    'o|object=s'        => \my $otype,
+    'e|empty'           => \my $empty_attr,
+    'fmt=s'             => \my $fmt,
+    'filefmt=s'         => \my $filefmt,
+    'ro'                => \my $with_ro,
+    'no-unexp|wo-unexp' => \my $nounexp,
+    'with-unexp'        => \my $unexp,
+    'help'              => sub { pod2usage(0) },
 ) or pod2usage();
 
@@ -55,11 +55,12 @@
 Query will be performed on this object. Default is the 'User' object.
 
-=item --noexp
+=item --with-unexp
 
-Take into account all objects (even non propagated ones, with attribute 'exported'=0)
+Take into account all objects (even non propagated ones, with attribute
+'exported'=0) (default)
 
-=item --exp
+=item --wo-unexp
 
-Take into account only propagated objects (attribute 'exported'=1) (default)
+Take into account only propagated objects (attribute 'exported'=1)
 
 =item -e|--empty
@@ -114,5 +115,5 @@
 $labase && $labase->load or die "Cannot load base";
 
-$labase->wexported($noexp ? 0 : 1);
+$labase->unexported($nounexp ? 0 : 1);
 
 if ($filefmt){
Index: /LATMOS-Accounts/bin/la-search
===================================================================
--- /LATMOS-Accounts/bin/la-search	(revision 848)
+++ /LATMOS-Accounts/bin/la-search	(revision 849)
@@ -27,11 +27,12 @@
 Perform search in this specific base instead default
 
-=item --noexp
+=item --with-unexp
 
-Take into account all objects (even non propagated ones, with attribute 'exported'=0)
+Take into account all objects (even non propagated ones, with attribute
+'exported'=0) (default)
 
-=item --exp
+=item --wo-unexp
 
-Take into account only propagated objects (attribute 'exported'=1) (default)
+Take into account only propagated objects (attribute 'exported'=1)
 
 =item --fmt format
@@ -77,11 +78,11 @@
 
 GetOptions(
-    'c|config=s' => \my $config,
-    'b|base=s'   => \my $base,
-    'o|object=s' => \my $otype,
-    'fmt=s'      => \my $fmt,
-    'noexp'      => \my $noexp,
-    'exp'        => \my $exp,
-    'help'       => sub { pod2usage(0) },
+    'c|config=s'        => \my $config,
+    'b|base=s'          => \my $base,
+    'o|object=s'        => \my $otype,
+    'fmt=s'             => \my $fmt,
+    'no-unexp|wo-unexp' => \my $nounexp,
+    'with-unexp'        => \my $unexp,
+    'help'              => sub { pod2usage(0) },
 ) or pod2usage();
 
@@ -94,5 +95,5 @@
 $labase && $labase->load or die "Cannot load base";
 
-$labase->wexported($noexp ? 0 : 1);
+$labase->unexported($nounexp ? 0 : 1);
 
 my @result = $labase->search_objects($otype, @ARGV);
Index: /LATMOS-Accounts/bin/la-web-directory
===================================================================
--- /LATMOS-Accounts/bin/la-web-directory	(revision 848)
+++ /LATMOS-Accounts/bin/la-web-directory	(revision 849)
@@ -26,11 +26,11 @@
 
 GetOptions(
-    'c|config=s' => \my $config,
-    'b|base=s'   => \my $base,
-    'noexp'      => \my $noexp,
-    'exp'        => \my $exp,
-    'noexpire'   => \my $noexpire,
-    'filter=s'   => \my @filters,
-    'help'       => sub { pod2usage(0) },
+    'c|config=s'        => \my $config,
+    'b|base=s'          => \my $base,
+    'wo-unexp|no-unexp' => \my $nounexp,
+    'with-unexp'        => \my $unexp,
+    'noexpire'          => \my $noexpire,
+    'filter=s'          => \my @filters,
+    'help'              => sub { pod2usage(0) },
 ) or pod2usage();
 
@@ -47,12 +47,11 @@
 Query this specific base instead of the default one.
 
-=item --noexp
+=item --with-unexp
 
 Take into account all objects (even non propagated ones, with attribute 'exported'=0)
-(default)
 
-=item --exp
+=item --wo-unexp
 
-Take into account only propagated objects (attribute 'exported'=1)
+Take into account only propagated objects (attribute 'exported'=1) (default)
 
 =item --noexpire
@@ -67,5 +66,5 @@
 $labase && $labase->load or die "Cannot load base";
 
-$labase->wexported($exp ? 1 : 0);
+$labase->unexported($unexp ? 1 : 0);
 my %users;
 my $now = strftime('%Y/%m/%d', gmtime);
Index: /LATMOS-Accounts/lib/LATMOS/Accounts/Bases.pm
===================================================================
--- /LATMOS-Accounts/lib/LATMOS/Accounts/Bases.pm	(revision 848)
+++ /LATMOS-Accounts/lib/LATMOS/Accounts/Bases.pm	(revision 849)
@@ -53,5 +53,7 @@
 }
 
-sub wexported {
+sub wexported { unexported(@_) }
+
+sub unexported {
     my ($self, $wexported) = @_;
     my $old = $self->{wexported};
Index: /LATMOS-Accounts/lib/LATMOS/Accounts/Cli.pm
===================================================================
--- /LATMOS-Accounts/lib/LATMOS/Accounts/Cli.pm	(revision 848)
+++ /LATMOS-Accounts/lib/LATMOS/Accounts/Cli.pm	(revision 849)
@@ -17,4 +17,28 @@
     my $env = LATMOS::Accounts::Cli->new({ prompt => sub { $_[0]->base->label . " cli > " }, },
         $labase);
+    $env->add_func('unexported', {
+        help => 'unexported yes|no|show - switch or show base mode regarding' .
+            ' unexported objects',
+        completion => sub {
+            if (!$_[2]) {
+                return qw(yes no show);
+            }
+        },
+        code => sub {
+            my ($env, $arg) = @_;
+            if ($arg eq 'yes') {
+                $env->base->unexported(1);
+                print $OUT "Unexported are now show";
+            } elsif ($arg eq 'no') {
+                $env->base->unexported(0);
+                print $OUT "Unexported are no longer show";
+            } elsif ($arg eq 'show') {
+                print $OUT "Unexported objects " . $env->base->unexported ?
+                "enable" : "disable";
+            } else {
+                print $OUT "wrong argument";
+            }
+        },
+    });
     $env->add_func('ls', {
             help => 'ls object_type - list object of type object_type', 